diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index d56951153b..10effe7387 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -197,7 +197,7 @@ typedef struct PgFdwModifyState
 	List	   *retrieved_attrs;	/* attr numbers retrieved by RETURNING */
 
 	/* info about parameters for prepared statement */
-	AttrNumber	ctidAttno;		/* attnum of input resjunk ctid column */
+	AttrNumber	ctidAttno;		/* attphysnum of input resjunk ctid column */
 	int			p_nums;			/* number of parameters to transmit */
 	FmgrInfo   *p_flinfo;		/* output conversion functions for them */
 
@@ -240,8 +240,8 @@ typedef struct PgFdwDirectModifyState
 	int			next_tuple;		/* index of next one to return */
 	Relation	resultRel;		/* relcache entry for the target relation */
 	AttrNumber *attnoMap;		/* array of attnums of input user columns */
-	AttrNumber	ctidAttno;		/* attnum of input ctid column */
-	AttrNumber	oidAttno;		/* attnum of input oid column */
+	AttrNumber	ctidAttno;		/* attphysnum of input ctid column */
+	AttrNumber	oidAttno;		/* attphysnum of input oid column */
 	bool		hasSystemCols;	/* are there system columns of resultRel? */
 
 	/* working memory context */
@@ -1800,14 +1800,14 @@ postgresPlanForeignModify(PlannerInfo *root,
 		 rel->trigdesc->trig_update_before_row))
 	{
 		TupleDesc	tupdesc = RelationGetDescr(rel);
-		int			attnum;
+		int			attphysnum;
 
-		for (attnum = 1; attnum <= tupdesc->natts; attnum++)
+		for (attphysnum = 1; attphysnum <= tupdesc->natts; attphysnum++)
 		{
-			Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+			Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 			if (!attr->attisdropped)
-				targetAttrs = lappend_int(targetAttrs, attnum);
+				targetAttrs = lappend_int(targetAttrs, attphysnum);
 		}
 	}
 	else if (operation == CMD_UPDATE)
@@ -2139,7 +2139,7 @@ postgresBeginForeignInsert(ModifyTableState *mtstate,
 	Relation	rel = resultRelInfo->ri_RelationDesc;
 	RangeTblEntry *rte;
 	TupleDesc	tupdesc = RelationGetDescr(rel);
-	int			attnum;
+	int			attphysnum;
 	int			values_end_len;
 	StringInfoData sql;
 	List	   *targetAttrs = NIL;
@@ -2164,12 +2164,12 @@ postgresBeginForeignInsert(ModifyTableState *mtstate,
 	initStringInfo(&sql);
 
 	/* We transmit all columns that are defined in the foreign table. */
-	for (attnum = 1; attnum <= tupdesc->natts; attnum++)
+	for (attphysnum = 1; attphysnum <= tupdesc->natts; attphysnum++)
 	{
-		Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+		Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 		if (!attr->attisdropped)
-			targetAttrs = lappend_int(targetAttrs, attnum);
+			targetAttrs = lappend_int(targetAttrs, attphysnum);
 	}
 
 	/* Check if we add the ON CONFLICT clause to the remote query. */
@@ -4026,8 +4026,8 @@ create_foreign_modify(EState *estate,
 		/* Set up for remaining transmittable parameters */
 		foreach(lc, fmstate->target_attrs)
 		{
-			int			attnum = lfirst_int(lc);
-			Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+			int			attphysnum = lfirst_int(lc);
+			Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 
 			Assert(!attr->attisdropped);
 
@@ -4279,15 +4279,15 @@ convert_prep_stmt_params(PgFdwModifyState *fmstate,
 			j = (tupleid != NULL) ? 1 : 0;
 			foreach(lc, fmstate->target_attrs)
 			{
-				int			attnum = lfirst_int(lc);
-				Form_pg_attribute attr = TupleDescAttr(tupdesc, attnum - 1);
+				int			attphysnum = lfirst_int(lc);
+				Form_pg_attribute attr = TupleDescAttr(tupdesc, attphysnum - 1);
 				Datum		value;
 				bool		isnull;
 
 				/* Ignore generated columns; they are set to DEFAULT */
 				if (attr->attgenerated)
 					continue;
-				value = slot_getattr(slots[i], attnum, &isnull);
+				value = slot_getattr(slots[i], attphysnum, &isnull);
 				if (isnull)
 					p_values[pindex] = NULL;
 				else
@@ -5330,10 +5330,10 @@ postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
 							   "  JOIN pg_namespace n ON "
 							   "    relnamespace = n.oid "
 							   "  LEFT JOIN pg_attribute a ON "
-							   "    attrelid = c.oid AND attnum > 0 "
+							   "    attrelid = c.oid AND attphysnum > 0 "
 							   "      AND NOT attisdropped "
 							   "  LEFT JOIN pg_attrdef ad ON "
-							   "    adrelid = c.oid AND adnum = attnum ");
+							   "    adrelid = c.oid AND adnum = attphysnum ");
 
 		if (import_collate)
 			appendStringInfoString(&buf,
@@ -5383,7 +5383,7 @@ postgresImportForeignSchema(ImportForeignSchemaStmt *stmt, Oid serverOid)
 		}
 
 		/* Append ORDER BY at the end of query to ensure output ordering */
-		appendStringInfoString(&buf, " ORDER BY c.relname, a.attnum");
+		appendStringInfoString(&buf, " ORDER BY c.relname, a.attphysnum");
 
 		/* Fetch the data */
 		res = pgfdw_exec_query(conn, buf.data, NULL);
diff --git a/contrib/sepgsql/dml.c b/contrib/sepgsql/dml.c
index 3bb98dfb06..4f43665f70 100644
--- a/contrib/sepgsql/dml.c
+++ b/contrib/sepgsql/dml.c
@@ -61,7 +61,7 @@ fixup_whole_row_references(Oid relOid, Bitmapset *columns)
 
 	for (attno = 1; attno <= natts; attno++)
 	{
-		tuple = SearchSysCache2(ATTNUM,
+		tuple = SearchSysCache2(ATTPHYSNUM,
 								ObjectIdGetDatum(relOid),
 								Int16GetDatum(attno));
 		if (!HeapTupleIsValid(tuple))
@@ -117,7 +117,7 @@ fixup_inherited_columns(Oid parentId, Oid childId, Bitmapset *columns)
 		}
 
 		attname = get_attname(parentId, attno, false);
-		attno = get_attnum(childId, attname);
+		attno = get_attphysnum(childId, attname);
 		if (attno == InvalidAttrNumber)
 			elog(ERROR, "cache lookup failed for attribute %s of relation %u",
 				 attname, childId);
@@ -232,7 +232,7 @@ check_relation_privileges(Oid relOid,
 
 	while ((index = bms_first_member(columns)) >= 0)
 	{
-		AttrNumber	attnum;
+		AttrNumber	attphysnum;
 		uint32		column_perms = 0;
 
 		if (bms_is_member(index, selected))
@@ -251,11 +251,11 @@ check_relation_privileges(Oid relOid,
 			continue;
 
 		/* obtain column's permission */
-		attnum = index + FirstLowInvalidHeapAttributeNumber;
+		attphysnum = index + FirstLowInvalidHeapAttributeNumber;
 
 		object.classId = RelationRelationId;
 		object.objectId = relOid;
-		object.objectSubId = attnum;
+		object.objectSubId = attphysnum;
 		audit_name = getObjectDescription(&object, false);
 
 		result = sepgsql_avc_check_perms(&object,
diff --git a/contrib/sepgsql/label.c b/contrib/sepgsql/label.c
index e4c98b7eae..97dccf385f 100644
--- a/contrib/sepgsql/label.c
+++ b/contrib/sepgsql/label.c
@@ -805,7 +805,7 @@ exec_object_restorecon(struct selabel_handle *sehnd, Oid catalogId)
 
 				object.classId = RelationRelationId;
 				object.objectId = attForm->attrelid;
-				object.objectSubId = attForm->attnum;
+				object.objectSubId = attForm->attphysnum;
 				break;
 
 			case ProcedureRelationId:
diff --git a/contrib/sepgsql/relation.c b/contrib/sepgsql/relation.c
index 8767988c4d..b1ad4a6636 100644
--- a/contrib/sepgsql/relation.c
+++ b/contrib/sepgsql/relation.c
@@ -40,7 +40,7 @@ static void sepgsql_index_modify(Oid indexOid);
  * although it also defines columns in addition to table.
  */
 void
-sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum)
+sepgsql_attribute_post_create(Oid relOid, AttrNumber attphysnum)
 {
 	Relation	rel;
 	ScanKeyData skey[2];
@@ -72,17 +72,17 @@ sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum)
 				BTEqualStrategyNumber, F_OIDEQ,
 				ObjectIdGetDatum(relOid));
 	ScanKeyInit(&skey[1],
-				Anum_pg_attribute_attnum,
+				Anum_pg_attribute_attphysnum,
 				BTEqualStrategyNumber, F_INT2EQ,
-				Int16GetDatum(attnum));
+				Int16GetDatum(attphysnum));
 
-	sscan = systable_beginscan(rel, AttributeRelidNumIndexId, true,
+	sscan = systable_beginscan(rel, AttributeRelidPhysNumIndexId, true,
 							   SnapshotSelf, 2, &skey[0]);
 
 	tuple = systable_getnext(sscan);
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for column %d of relation %u",
-			 attnum, relOid);
+			 attphysnum, relOid);
 
 	attForm = (Form_pg_attribute) GETSTRUCT(tuple);
 
@@ -114,7 +114,7 @@ sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum)
 	 */
 	object.classId = RelationRelationId;
 	object.objectId = relOid;
-	object.objectSubId = attnum;
+	object.objectSubId = attphysnum;
 	SetSecurityLabel(&object, SEPGSQL_LABEL_TAG, ncontext);
 
 	systable_endscan(sscan);
@@ -130,7 +130,7 @@ sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum)
  * It checks privileges to drop the supplied column.
  */
 void
-sepgsql_attribute_drop(Oid relOid, AttrNumber attnum)
+sepgsql_attribute_drop(Oid relOid, AttrNumber attphysnum)
 {
 	ObjectAddress object;
 	char	   *audit_name;
@@ -144,7 +144,7 @@ sepgsql_attribute_drop(Oid relOid, AttrNumber attnum)
 	 */
 	object.classId = RelationRelationId;
 	object.objectId = relOid;
-	object.objectSubId = attnum;
+	object.objectSubId = attphysnum;
 	audit_name = getObjectIdentity(&object, false);
 
 	sepgsql_avc_check_perms(&object,
@@ -162,7 +162,7 @@ sepgsql_attribute_drop(Oid relOid, AttrNumber attnum)
  * by the `seclabel'.
  */
 void
-sepgsql_attribute_relabel(Oid relOid, AttrNumber attnum,
+sepgsql_attribute_relabel(Oid relOid, AttrNumber attphysnum,
 						  const char *seclabel)
 {
 	ObjectAddress object;
@@ -176,7 +176,7 @@ sepgsql_attribute_relabel(Oid relOid, AttrNumber attnum,
 
 	object.classId = RelationRelationId;
 	object.objectId = relOid;
-	object.objectSubId = attnum;
+	object.objectSubId = attphysnum;
 	audit_name = getObjectIdentity(&object, false);
 
 	/*
@@ -206,7 +206,7 @@ sepgsql_attribute_relabel(Oid relOid, AttrNumber attnum,
  * It checks privileges to alter the supplied column.
  */
 void
-sepgsql_attribute_setattr(Oid relOid, AttrNumber attnum)
+sepgsql_attribute_setattr(Oid relOid, AttrNumber attphysnum)
 {
 	ObjectAddress object;
 	char	   *audit_name;
@@ -220,7 +220,7 @@ sepgsql_attribute_setattr(Oid relOid, AttrNumber attnum)
 	 */
 	object.classId = RelationRelationId;
 	object.objectId = relOid;
-	object.objectSubId = attnum;
+	object.objectSubId = attphysnum;
 	audit_name = getObjectIdentity(&object, false);
 
 	sepgsql_avc_check_perms(&object,
@@ -363,7 +363,7 @@ sepgsql_relation_post_create(Oid relOid)
 					BTEqualStrategyNumber, F_OIDEQ,
 					ObjectIdGetDatum(relOid));
 
-		ascan = systable_beginscan(arel, AttributeRelidNumIndexId, true,
+		ascan = systable_beginscan(arel, AttributeRelidPhysNumIndexId, true,
 								   SnapshotSelf, 1, &akey);
 
 		while (HeapTupleIsValid(atup = systable_getnext(ascan)))
@@ -392,7 +392,7 @@ sepgsql_relation_post_create(Oid relOid)
 
 			object.classId = RelationRelationId;
 			object.objectId = relOid;
-			object.objectSubId = attForm->attnum;
+			object.objectSubId = attForm->attphysnum;
 			SetSecurityLabel(&object, SEPGSQL_LABEL_TAG, ccontext);
 
 			pfree(ccontext);
@@ -490,7 +490,7 @@ sepgsql_relation_drop(Oid relOid)
 		HeapTuple	atttup;
 		int			i;
 
-		attrList = SearchSysCacheList1(ATTNUM, ObjectIdGetDatum(relOid));
+		attrList = SearchSysCacheList1(ATTPHYSNUM, ObjectIdGetDatum(relOid));
 		for (i = 0; i < attrList->n_members; i++)
 		{
 			atttup = &attrList->members[i]->tuple;
@@ -501,7 +501,7 @@ sepgsql_relation_drop(Oid relOid)
 
 			object.classId = RelationRelationId;
 			object.objectId = relOid;
-			object.objectSubId = attForm->attnum;
+			object.objectSubId = attForm->attphysnum;
 			audit_name = getObjectIdentity(&object, false);
 
 			sepgsql_avc_check_perms(&object,
diff --git a/contrib/sepgsql/sepgsql.h b/contrib/sepgsql/sepgsql.h
index 70f6203496..86e1562630 100644
--- a/contrib/sepgsql/sepgsql.h
+++ b/contrib/sepgsql/sepgsql.h
@@ -307,11 +307,11 @@ extern void sepgsql_schema_rename(Oid namespaceId);
 /*
  * relation.c
  */
-extern void sepgsql_attribute_post_create(Oid relOid, AttrNumber attnum);
-extern void sepgsql_attribute_drop(Oid relOid, AttrNumber attnum);
-extern void sepgsql_attribute_relabel(Oid relOid, AttrNumber attnum,
+extern void sepgsql_attribute_post_create(Oid relOid, AttrNumber attphysnum);
+extern void sepgsql_attribute_drop(Oid relOid, AttrNumber attphysnum);
+extern void sepgsql_attribute_relabel(Oid relOid, AttrNumber attphysnum,
 									  const char *seclabel);
-extern void sepgsql_attribute_setattr(Oid relOid, AttrNumber attnum);
+extern void sepgsql_attribute_setattr(Oid relOid, AttrNumber attphysnum);
 extern void sepgsql_relation_post_create(Oid relOid);
 extern void sepgsql_relation_drop(Oid relOid);
 extern void sepgsql_relation_truncate(Oid relOid);
diff --git a/contrib/spi/autoinc.c b/contrib/spi/autoinc.c
index 8bf742230e..1b82c2ae29 100644
--- a/contrib/spi/autoinc.c
+++ b/contrib/spi/autoinc.c
@@ -70,23 +70,23 @@ autoinc(PG_FUNCTION_ARGS)
 
 	for (i = 0; i < nargs;)
 	{
-		int			attnum = SPI_fnumber(tupdesc, args[i]);
+		int			attphysnum = SPI_fnumber(tupdesc, args[i]);
 		int32		val;
 		Datum		seqname;
 
-		if (attnum <= 0)
+		if (attphysnum <= 0)
 			ereport(ERROR,
 					(errcode(ERRCODE_TRIGGERED_ACTION_EXCEPTION),
 					 errmsg("\"%s\" has no attribute \"%s\"",
 							relname, args[i])));
 
-		if (SPI_gettypeid(tupdesc, attnum) != INT4OID)
+		if (SPI_gettypeid(tupdesc, attphysnum) != INT4OID)
 			ereport(ERROR,
 					(errcode(ERRCODE_TRIGGERED_ACTION_EXCEPTION),
 					 errmsg("attribute \"%s\" of \"%s\" must be type INT4",
 							args[i], relname)));
 
-		val = DatumGetInt32(SPI_getbinval(rettuple, tupdesc, attnum, &isnull));
+		val = DatumGetInt32(SPI_getbinval(rettuple, tupdesc, attphysnum, &isnull));
 
 		if (!isnull && val != 0)
 		{
@@ -95,7 +95,7 @@ autoinc(PG_FUNCTION_ARGS)
 		}
 
 		i++;
-		chattrs[chnattrs] = attnum;
+		chattrs[chnattrs] = attphysnum;
 		seqname = CStringGetTextDatum(args[i]);
 		newvals[chnattrs] = DirectFunctionCall1(nextval, seqname);
 		/* nextval now returns int64; coerce down to int32 */
diff --git a/contrib/spi/insert_username.c b/contrib/spi/insert_username.c
index a2e1747ff7..fbf3514942 100644
--- a/contrib/spi/insert_username.c
+++ b/contrib/spi/insert_username.c
@@ -31,7 +31,7 @@ insert_username(PG_FUNCTION_ARGS)
 	Relation	rel;			/* triggered relation */
 	HeapTuple	rettuple = NULL;
 	TupleDesc	tupdesc;		/* tuple description */
-	int			attnum;
+	int			attphysnum;
 
 	/* sanity checks from autoinc.c */
 	if (!CALLED_AS_TRIGGER(fcinfo))
@@ -65,14 +65,14 @@ insert_username(PG_FUNCTION_ARGS)
 	args = trigger->tgargs;
 	tupdesc = rel->rd_att;
 
-	attnum = SPI_fnumber(tupdesc, args[0]);
+	attphysnum = SPI_fnumber(tupdesc, args[0]);
 
-	if (attnum <= 0)
+	if (attphysnum <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_TRIGGERED_ACTION_EXCEPTION),
 				 errmsg("\"%s\" has no attribute \"%s\"", relname, args[0])));
 
-	if (SPI_gettypeid(tupdesc, attnum) != TEXTOID)
+	if (SPI_gettypeid(tupdesc, attphysnum) != TEXTOID)
 		ereport(ERROR,
 				(errcode(ERRCODE_TRIGGERED_ACTION_EXCEPTION),
 				 errmsg("attribute \"%s\" of \"%s\" must be type TEXT",
@@ -84,7 +84,7 @@ insert_username(PG_FUNCTION_ARGS)
 
 	/* construct new tuple */
 	rettuple = heap_modify_tuple_by_cols(rettuple, tupdesc,
-										 1, &attnum, &newval, &newnull);
+										 1, &attphysnum, &newval, &newnull);
 
 	pfree(relname);
 
diff --git a/contrib/spi/moddatetime.c b/contrib/spi/moddatetime.c
index 3eb7004de9..6291ca4816 100644
--- a/contrib/spi/moddatetime.c
+++ b/contrib/spi/moddatetime.c
@@ -32,7 +32,7 @@ moddatetime(PG_FUNCTION_ARGS)
 	TriggerData *trigdata = (TriggerData *) fcinfo->context;
 	Trigger    *trigger;		/* to get trigger name */
 	int			nargs;			/* # of arguments */
-	int			attnum;			/* positional number of field to change */
+	int			attphysnum;			/* positional number of field to change */
 	Oid			atttypid;		/* type OID of field to change */
 	Datum		newdt;			/* The current datetime. */
 	bool		newdtnull;		/* null flag for it */
@@ -82,13 +82,13 @@ moddatetime(PG_FUNCTION_ARGS)
 	 * This gets the position in the tuple of the field we want. args[0] being
 	 * the name of the field to update, as passed in from the trigger.
 	 */
-	attnum = SPI_fnumber(tupdesc, args[0]);
+	attphysnum = SPI_fnumber(tupdesc, args[0]);
 
 	/*
 	 * This is where we check to see if the field we are supposed to update
 	 * even exists.
 	 */
-	if (attnum <= 0)
+	if (attphysnum <= 0)
 		ereport(ERROR,
 				(errcode(ERRCODE_TRIGGERED_ACTION_EXCEPTION),
 				 errmsg("\"%s\" has no attribute \"%s\"",
@@ -98,7 +98,7 @@ moddatetime(PG_FUNCTION_ARGS)
 	 * Check the target field has an allowed type, and get the current
 	 * datetime as a value of that type.
 	 */
-	atttypid = SPI_gettypeid(tupdesc, attnum);
+	atttypid = SPI_gettypeid(tupdesc, attphysnum);
 	if (atttypid == TIMESTAMPOID)
 		newdt = DirectFunctionCall3(timestamp_in,
 									CStringGetDatum("now"),
@@ -121,7 +121,7 @@ moddatetime(PG_FUNCTION_ARGS)
 
 	/* Replace the attnum'th column with newdt */
 	rettuple = heap_modify_tuple_by_cols(rettuple, tupdesc,
-										 1, &attnum, &newdt, &newdtnull);
+										 1, &attphysnum, &newdt, &newdtnull);
 
 	/* Clean up */
 	pfree(relname);
diff --git a/contrib/test_decoding/test_decoding.c b/contrib/test_decoding/test_decoding.c
index 3736da6784..3954427214 100644
--- a/contrib/test_decoding/test_decoding.c
+++ b/contrib/test_decoding/test_decoding.c
@@ -554,7 +554,7 @@ tuple_to_stringinfo(StringInfo s, TupleDesc tupdesc, HeapTuple tuple, bool skip_
 		 * Don't print system columns, oid will already have been printed if
 		 * present.
 		 */
-		if (attr->attnum < 0)
+		if (attr->attphysnum < 0)
 			continue;
 
 		typid = attr->atttypid;
diff --git a/contrib/vacuumlo/vacuumlo.c b/contrib/vacuumlo/vacuumlo.c
index b7c8f2c805..6a86c8cec8 100644
--- a/contrib/vacuumlo/vacuumlo.c
+++ b/contrib/vacuumlo/vacuumlo.c
@@ -193,7 +193,7 @@ vacuumlo(const char *database, const struct _param *param)
 	buf[0] = '\0';
 	strcat(buf, "SELECT s.nspname, c.relname, a.attname ");
 	strcat(buf, "FROM pg_class c, pg_attribute a, pg_namespace s, pg_type t ");
-	strcat(buf, "WHERE a.attnum > 0 AND NOT a.attisdropped ");
+	strcat(buf, "WHERE a.attphysnum > 0 AND NOT a.attisdropped ");
 	strcat(buf, "      AND a.attrelid = c.oid ");
 	strcat(buf, "      AND a.atttypid = t.oid ");
 	strcat(buf, "      AND c.relnamespace = s.oid ");
diff --git a/doc/src/sgml/amcheck.sgml b/doc/src/sgml/amcheck.sgml
index 5d61a33936..bd6e7ef77f 100644
--- a/doc/src/sgml/amcheck.sgml
+++ b/doc/src/sgml/amcheck.sgml
@@ -91,7 +91,7 @@ ORDER BY c.relpages DESC LIMIT 10;
                 | pg_description_o_c_o_index      |       21
                 | pg_attribute_relid_attnam_index |       14
                 | pg_proc_oid_index               |       10
-                | pg_attribute_relid_attnum_index |        9
+                | pg_attribute_relid_attphysnum_index |        9
                 | pg_amproc_fam_proc_index        |        5
                 | pg_amop_opr_fam_index           |        5
                 | pg_amop_fam_strat_index         |        5
@@ -213,7 +213,7 @@ SET client_min_messages = DEBUG1;
                     endblock bigint,
                     blkno OUT bigint,
                     offnum OUT integer,
-                    attnum OUT integer,
+                    attphysnum OUT integer,
                     msg OUT text)
       returns setof record
      </function>
diff --git a/doc/src/sgml/fdwhandler.sgml b/doc/src/sgml/fdwhandler.sgml
index d0b5951019..e0f95fcfd4 100644
--- a/doc/src/sgml/fdwhandler.sgml
+++ b/doc/src/sgml/fdwhandler.sgml
@@ -1759,7 +1759,7 @@ GetForeignTable(Oid relid);
     <para>
 <programlisting>
 List *
-GetForeignColumnOptions(Oid relid, AttrNumber attnum);
+GetForeignColumnOptions(Oid relid, AttrNumber attphysnum);
 </programlisting>
 
      This function returns the per-column FDW options for the column with the
diff --git a/doc/src/sgml/pageinspect.sgml b/doc/src/sgml/pageinspect.sgml
index d4ee34ee0f..4bfcf3c56d 100644
--- a/doc/src/sgml/pageinspect.sgml
+++ b/doc/src/sgml/pageinspect.sgml
@@ -564,8 +564,8 @@ test=# SELECT * FROM brin_revmap_data(get_raw_page('brinidx', 2)) LIMIT 5;
 <screen>
 test=# SELECT * FROM brin_page_items(get_raw_page('brinidx', 5),
                                      'brinidx')
-       ORDER BY blknum, attnum LIMIT 6;
- itemoffset | blknum | attnum | allnulls | hasnulls | placeholder |    value
+       ORDER BY blknum, attphysnum LIMIT 6;
+ itemoffset | blknum | attphysnum | allnulls | hasnulls | placeholder |    value
 ------------+--------+--------+----------+----------+-------------+--------------
         137 |      0 |      1 | t        | f        | f           |
         137 |      0 |      2 | f        | f        | f           | {1 .. 88}
diff --git a/doc/src/sgml/ref/psql-ref.sgml b/doc/src/sgml/ref/psql-ref.sgml
index 65bb0a6a3f..b029355b50 100644
--- a/doc/src/sgml/ref/psql-ref.sgml
+++ b/doc/src/sgml/ref/psql-ref.sgml
@@ -2289,7 +2289,7 @@ Tue Oct 26 21:40:57 CEST 1999
 <programlisting>
 =&gt; <userinput>SELECT format('create index on my_table(%I)', attname)</userinput>
 -&gt; <userinput>FROM pg_attribute</userinput>
--&gt; <userinput>WHERE attrelid = 'my_table'::regclass AND attnum &gt; 0</userinput>
+-&gt; <userinput>WHERE attrelid = 'my_table'::regclass AND attphysnum &gt; 0</userinput>
 -&gt; <userinput>ORDER BY attnum</userinput>
 -&gt; <userinput>\gexec</userinput>
 CREATE INDEX
diff --git a/doc/src/sgml/sources.sgml b/doc/src/sgml/sources.sgml
index 5186d75d61..b6dab7ff47 100644
--- a/doc/src/sgml/sources.sgml
+++ b/doc/src/sgml/sources.sgml
@@ -326,7 +326,7 @@ ereport(ERROR,
    </listitem>
    <listitem>
     <para>
-     <function>errtablecol(Relation rel, int attnum)</function> specifies
+     <function>errtablecol(Relation rel, int attphysnum)</function> specifies
      a column whose name, table name, and schema name should be included as
      auxiliary fields in the error report.
     </para>
diff --git a/doc/src/sgml/trigger.sgml b/doc/src/sgml/trigger.sgml
index 04e702a795..6234edbc12 100644
--- a/doc/src/sgml/trigger.sgml
+++ b/doc/src/sgml/trigger.sgml
@@ -803,7 +803,7 @@ typedef struct Trigger
        <para>
         As an example, to determine whether a column with attribute number
         <varname>attnum</varname> (1-based) is a member of this bitmap set,
-        call <literal>bms_is_member(attnum -
+        call <literal>bms_is_member(attphysnum -
         FirstLowInvalidHeapAttributeNumber,
         trigdata->tg_updatedcols))</literal>.
        </para>
diff --git a/doc/src/sgml/xaggr.sgml b/doc/src/sgml/xaggr.sgml
index bdad8d3dc2..b983149059 100644
--- a/doc/src/sgml/xaggr.sgml
+++ b/doc/src/sgml/xaggr.sgml
@@ -319,7 +319,7 @@ CREATE AGGREGATE array_accum (anycompatible)
 <programlisting>
 SELECT attrelid::regclass, array_accum(attname)
     FROM pg_attribute
-    WHERE attnum &gt; 0 AND attrelid = 'pg_tablespace'::regclass
+    WHERE attphysnum &gt; 0 AND attrelid = 'pg_tablespace'::regclass
     GROUP BY attrelid;
 
    attrelid    |              array_accum
@@ -329,7 +329,7 @@ SELECT attrelid::regclass, array_accum(attname)
 
 SELECT attrelid::regclass, array_accum(atttypid::regtype)
     FROM pg_attribute
-    WHERE attnum &gt; 0 AND attrelid = 'pg_tablespace'::regclass
+    WHERE attphysnum &gt; 0 AND attrelid = 'pg_tablespace'::regclass
     GROUP BY attrelid;
 
    attrelid    |        array_accum
diff --git a/src/backend/access/brin/brin_tuple.c b/src/backend/access/brin/brin_tuple.c
index c0e2dbd23b..f79840a357 100644
--- a/src/backend/access/brin/brin_tuple.c
+++ b/src/backend/access/brin/brin_tuple.c
@@ -634,7 +634,7 @@ brin_deconstruct_tuple(BrinDesc *brdesc,
 					   char *tp, bits8 *nullbits, bool nulls,
 					   Datum *values, bool *allnulls, bool *hasnulls)
 {
-	int			attnum;
+	int			attphysnum;
 	int			stored;
 	TupleDesc	diskdsc;
 	long		off;
@@ -645,14 +645,14 @@ brin_deconstruct_tuple(BrinDesc *brdesc,
 	 * 1 for a null value (rather than a 1 for a not null value as is the
 	 * att_isnull convention used elsewhere.)  See brin_form_tuple.
 	 */
-	for (attnum = 0; attnum < brdesc->bd_tupdesc->natts; attnum++)
+	for (attphysnum = 0; attphysnum < brdesc->bd_tupdesc->natts; attphysnum++)
 	{
 		/*
 		 * the "all nulls" bit means that all values in the page range for
 		 * this column are nulls.  Therefore there are no values in the tuple
 		 * data area.
 		 */
-		allnulls[attnum] = nulls && !att_isnull(attnum, nullbits);
+		allnulls[attphysnum] = nulls && !att_isnull(attphysnum, nullbits);
 
 		/*
 		 * the "has nulls" bit means that some tuples have nulls, but others
@@ -661,8 +661,8 @@ brin_deconstruct_tuple(BrinDesc *brdesc,
 		 *
 		 * The hasnulls bits follow the allnulls bits in the same bitmask.
 		 */
-		hasnulls[attnum] =
-			nulls && !att_isnull(brdesc->bd_tupdesc->natts + attnum, nullbits);
+		hasnulls[attphysnum] =
+			nulls && !att_isnull(brdesc->bd_tupdesc->natts + attphysnum, nullbits);
 	}
 
 	/*
@@ -673,18 +673,18 @@ brin_deconstruct_tuple(BrinDesc *brdesc,
 	diskdsc = brtuple_disk_tupdesc(brdesc);
 	stored = 0;
 	off = 0;
-	for (attnum = 0; attnum < brdesc->bd_tupdesc->natts; attnum++)
+	for (attphysnum = 0; attphysnum < brdesc->bd_tupdesc->natts; attphysnum++)
 	{
 		int			datumno;
 
-		if (allnulls[attnum])
+		if (allnulls[attphysnum])
 		{
-			stored += brdesc->bd_info[attnum]->oi_nstored;
+			stored += brdesc->bd_info[attphysnum]->oi_nstored;
 			continue;
 		}
 
 		for (datumno = 0;
-			 datumno < brdesc->bd_info[attnum]->oi_nstored;
+			 datumno < brdesc->bd_info[attphysnum]->oi_nstored;
 			 datumno++)
 		{
 			Form_pg_attribute thisatt = TupleDescAttr(diskdsc, stored);
diff --git a/src/backend/access/common/attmap.c b/src/backend/access/common/attmap.c
index 896f82a22b..d84b1bcdc4 100644
--- a/src/backend/access/common/attmap.c
+++ b/src/backend/access/common/attmap.c
@@ -231,7 +231,7 @@ build_attrmap_by_name(TupleDesc indesc,
 									   attname,
 									   format_type_be(outdesc->tdtypeid),
 									   format_type_be(indesc->tdtypeid))));
-				attrMap->attnums[i] = inatt->attnum;
+				attrMap->attnums[i] = inatt->attphysnum;
 				break;
 			}
 		}
